%vycisteni pracovni plochy
clear;
close all;
clc;

N = 30; %velikost matice

%generator matice A a pravestrany b
M = Generator(N);
[A,b] = M.vygenerujUniformRP(1,100);

%pretypovani kvuli stejnym vstupnim hodnotam
A = single(A)
b = single(b)

%ulozeni vytvorenych matic
file = fopen('A.txt', 'w');
fprintf(file, '%c,\n', A);
fclose(file);

file = fopen('B.txt', 'w');
fprintf(file, '%c,\n', b);
fclose(file);


%referenci vysledek reseni soustavy rovnic
if (det(A) ~= 0) %overeni regularnosti matice
   xRef = inv(A) * b
end

%vytvoreni objektu
oQR = QR();
oSVD = SVD();
oLU = LU();
oBS = BS();

% %SVD rozklad a vypocet soustavy rovnic Householder
% [B, V, U] = oSVD.upbid(A);
% Q = SVD.Housprod(V);
% P = SVD.Housprod(U);
% SVDx = P * inv(B) * Q' * b;
% 
% %LU
% [lu, pvt] = oLU.LUfactor(A);
% LUx = oLU.LUsolve(lu, b, pvt); 

%QR Modified Gram-Schmidt
[Q,R] = oQR.GramSchmidtDSP(A)
% QRGSxDSP = inv(R) * Q' * b;

%Zptn substituce
xBS = oBS.mgss(Q,R,b)
% [Q,R] = oQR.GramSchmidt(A);
% QRGSx = inv(R) * Q' * b;

%QR Householder
%[R,y] = oQR.HouseholderDSP(A,b);
% R = oQR.Householder(A);
% [Q,y] = oQR.Qxb(b);
% QRHx = inv(R) * y;

%ulozeni vyledku do souboru
file = fopen('X.txt', 'w');
fprintf(file, '%c\n', xBS);
fclose(file);
